/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Sensor_User.java
 *
 * Created on 04/04/2011, 14:14:41
 */

package modelagemestática;



import java.awt.image.BufferedImage;
import java.io.*;
import java.net.*;
import java.text.ParseException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *
 * @author Gregory
 */
public class Sensor_User extends javax.swing.JFrame {

     private Socket armazena_cliente;

    /** Creates new form Sensor_User */
    public Sensor_User(Socket armazena) {
        initComponents();
        BufferedImage image = new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB);
             this.setIconImage(image);

        armazena_cliente = armazena;
        Nomes.setEditable(false);
        this.setTitle("INFORMAÇÕES SOBRE SENSORES");
        this.setLocationRelativeTo(null);
        // adicionar do banco de dados os logins dos usuarios
         try {

            int cont_aux = 0;
            // OBTEM O CANAL DE SAIDA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            OutputStream tx = armazena_cliente.getOutputStream();
            DataOutputStream canalSaida = new DataOutputStream( tx );
            // OBTEM O CANAL DE ENTRADA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            InputStream rx = armazena_cliente.getInputStream( );
            DataInputStream canalEntrada = new DataInputStream( rx );



            // recebe dados
            int cont_nomes = canalEntrada.readInt(); // numero de nomes existentes

            while(cont_aux < cont_nomes){
            String nome_recebido = canalEntrada.readUTF();  // recebe nome
//             adiciona no jcombobox
            Nomes.addItem(nome_recebido);
                cont_aux++;
            }




        } catch (IOException ex) {
            Logger.getLogger(Users_Info.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    private Sensor_User() {
        throw new UnsupportedOperationException("Not yet implemented");
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        Nomes = new javax.swing.JComboBox();
        OK = new javax.swing.JButton();
        Cancelar = new javax.swing.JButton();
        Data_Inicio = new com.toedter.calendar.JDateChooser();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        Data_Fim = new com.toedter.calendar.JDateChooser();
        jLabel5 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setName("Form"); // NOI18N

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 287, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 457, Short.MAX_VALUE)
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, statusPanelLayout.createSequentialGroup()
                .addGap(2, 2, 2)
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(modelagemestática.ModelagemEstáticaApp.class).getContext().getResourceMap(Sensor_User.class);
        jPanel1.setBackground(resourceMap.getColor("jPanel1.background")); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        jLabel2.setFont(resourceMap.getFont("jLabel3.font")); // NOI18N
        jLabel2.setForeground(resourceMap.getColor("jLabel2.foreground")); // NOI18N
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        Nomes.setName("Nomes"); // NOI18N

        OK.setText(resourceMap.getString("OK.text")); // NOI18N
        OK.setName("OK"); // NOI18N
        OK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OKActionPerformed(evt);
            }
        });

        Cancelar.setText(resourceMap.getString("Cancelar.text")); // NOI18N
        Cancelar.setName("Cancelar"); // NOI18N
        Cancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelarActionPerformed(evt);
            }
        });

        Data_Inicio.setName("Data_Inicio"); // NOI18N

        jLabel3.setFont(resourceMap.getFont("jLabel3.font")); // NOI18N
        jLabel3.setForeground(resourceMap.getColor("jLabel3.foreground")); // NOI18N
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel4.setFont(resourceMap.getFont("jLabel3.font")); // NOI18N
        jLabel4.setForeground(resourceMap.getColor("jLabel4.foreground")); // NOI18N
        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        Data_Fim.setName("Data_Fim"); // NOI18N

        jLabel5.setFont(resourceMap.getFont("jLabel3.font")); // NOI18N
        jLabel5.setForeground(resourceMap.getColor("jLabel5.foreground")); // NOI18N
        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addGroup(jPanel1Layout.createSequentialGroup()
                                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING))
                                    .addGap(248, 248, 248))
                                .addComponent(jLabel2))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel5)
                                .addGap(31, 31, 31)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(Nomes, 0, 145, Short.MAX_VALUE)
                                    .addComponent(Data_Inicio, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Data_Fim, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(OK, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)))
                .addComponent(Cancelar)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGap(83, 83, 83)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(Nomes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(34, 34, 34)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(Data_Inicio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(30, 30, 30)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel4)
                    .addComponent(Data_Fim, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 89, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Cancelar)
                    .addComponent(OK))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(statusPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void OKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OKActionPerformed
        // TODO add your handling code here:
        //pegar nome do usuário

        String S = (String)Nomes.getSelectedItem();

        // abrir nova janela com ficha do usuario
        try {
            // envia para o atendente a opção de Cadastrar Usuário


            // OBTEM O CANAL DE SAIDA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            OutputStream tx = armazena_cliente.getOutputStream( );
            DataOutputStream canalSaida = new DataOutputStream( tx );

            // OBTEM O CANAL DE ENTRADA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            InputStream rx = armazena_cliente.getInputStream( );
            DataInputStream canalEntrada = new DataInputStream( rx );



            //pegar data_inicio e data_final

            if((Data_Inicio.getDate() == null) || (Data_Inicio.getDate().equals("")) || (Data_Fim.getDate() == null) || (Data_Fim.getDate().equals(""))){

             JOptionPane.showMessageDialog(null, "Favor selecionar as duas datas!", "Erro", JOptionPane.ERROR_MESSAGE, null);
               try{
            

            int opcao_escolhida = 5002;
            canalSaida.writeInt(opcao_escolhida);

            this.dispose();


        } catch (IOException ex) {
            Logger.getLogger(Sensor_User.class.getName()).log(Level.SEVERE, null, ex);
        }
            }else{


            SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
            System.out.println(sdf.format(Data_Inicio.getDate()));
            String Data_Ini = sdf.format(Data_Inicio.getDate()); // string pega

            SimpleDateFormat sdf1 = new SimpleDateFormat("dd/MM/yyyy");
            System.out.println(sdf1.format(Data_Fim.getDate()));
            String Data_F = sdf.format(Data_Fim.getDate()); // string pega

            Date DI = new Date();
            Date DF = new Date();

            try {
                DI = sdf.parse(Data_Ini);
                DF = sdf1.parse(Data_F);
            } catch (ParseException ex) {
                Logger.getLogger(Info_DocUser.class.getName()).log(Level.SEVERE, null, ex);
            }

            if(DF.before(DI)){ // se a data final vier antes da data inicial = erro
                JOptionPane.showMessageDialog(null, "A DATA INICIAL É MAIOR QUE DATA FINAL!", "Erro", JOptionPane.ERROR_MESSAGE, null);
                // limpar campos de data
                Data_Inicio.setDate(null);
                Data_Fim.setDate(null);
            }else{

                int opcao_escolhida = 5001;
                canalSaida.writeInt(opcao_escolhida);
                System.out.println("MANDOU A OPCAO FICHA_Sensor_User");
                
                
                this.dispose();
                Sensor_Ficha user = new Sensor_Ficha(armazena_cliente, S, Data_Ini, Data_F);
                user.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
                
                

            }

          }
        } catch (IOException ex) {
            Logger.getLogger(Sensor_User.class.getName()).log(Level.SEVERE, null, ex);
        }


        // this.dispose();
}//GEN-LAST:event_OKActionPerformed

    private void CancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelarActionPerformed
        // TODO add your handling code here:

        try{
            // OBTEM O CANAL DE SAIDA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            OutputStream tx = armazena_cliente.getOutputStream();
            DataOutputStream canalSaida = new DataOutputStream( tx );
            // OBTEM O CANAL DE ENTRADA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            InputStream rx = armazena_cliente.getInputStream( );
            DataInputStream canalEntrada = new DataInputStream( rx );

            int opcao_escolhida = 5002;
            canalSaida.writeInt(opcao_escolhida);

            this.dispose();


        } catch (IOException ex) {
            Logger.getLogger(Sensor_User.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_CancelarActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Sensor_User().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Cancelar;
    private com.toedter.calendar.JDateChooser Data_Fim;
    private com.toedter.calendar.JDateChooser Data_Inicio;
    private javax.swing.JComboBox Nomes;
    private javax.swing.JButton OK;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables

}
