/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Ficha_Info_Proj.java
 *
 * Created on 14/01/2011, 15:23:07
 */

package modelagemestática;
import java.awt.image.BufferedImage;
import java.io.*;
import java.net.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;


/**
 *
 * @author gregory.wanderley
 */
public class Ficha_Info_Proj extends javax.swing.JFrame {

    private Socket armazena_cliente;
    private String nome;
    private String Data_I;
    private String Data_F;



     public Ficha_Info_Proj(Socket armazena, String S) {
        initComponents();



        BufferedImage image = new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB);
             this.setIconImage(image);
             this.setTitle("INFORMAÇÕES SOBRE PROJETOS");
             this.setLocationRelativeTo(null);
        armazena_cliente = armazena;
        nome = S;

        Tabela.setEnabled(false);
        Object colunas[] = { "Nome do Projeto" , "Orcamento", "Data Inicial", "Data Final" };

        Object linhas [][] = {


         };

        DefaultTableModel modelo = new DefaultTableModel(linhas, colunas);

        Tabela.setModel(modelo);
        
        try {


            // OBTEM O CANAL DE SAIDA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            OutputStream tx = armazena_cliente.getOutputStream();
            DataOutputStream canalSaida = new DataOutputStream( tx );
            // OBTEM O CANAL DE ENTRADA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
            InputStream rx = armazena_cliente.getInputStream( );
            DataInputStream canalEntrada = new DataInputStream( rx );

            // envia o login do usuário conectado
            canalSaida.writeUTF(nome);


            int cont = canalEntrada.readInt(); // número de registros


            int cont_aux = 0;
            DefaultTableModel modelo1 = (DefaultTableModel) Tabela.getModel();

            while(cont_aux < cont){
               String Orcamento = canalEntrada.readUTF();
               String DataInicial = canalEntrada.readUTF();
               String DataFinal = canalEntrada.readUTF();
               modelo1.addRow(new String [] {nome, Orcamento, DataInicial, DataFinal});
                cont_aux++;
            }

            Nome_D.setText(nome);
           // D_I.setText(Data_I);
           // D_F.setText(Data_F);
            if(cont == 0){ // não existem registros no período solicitado
                JOptionPane.showMessageDialog(null, "Não Existem Registros do Usuário Para o Período Solicitado!", "Atenção", JOptionPane.INFORMATION_MESSAGE, null);

            }


        } catch (IOException ex) {
            Logger.getLogger(Cadastro_Atualiza.class.getName()).log(Level.SEVERE, null, ex);
        }




    }



    /** Creates new form Ficha_Info_Proj */
    public Ficha_Info_Proj() {
        initComponents();

        BufferedImage image = new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB);
             this.setIconImage(image);
             this.setTitle("INFORMAÇÕES SOBRE PROJETOS");
             this.setLocationRelativeTo(null);

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        OK = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        Tabela = new javax.swing.JTable();
        Nome_D = new javax.swing.JLabel();
        statusPanel1 = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator1 = new javax.swing.JSeparator();
        statusMessageLabel1 = new javax.swing.JLabel();
        statusAnimationLabel1 = new javax.swing.JLabel();
        progressBar1 = new javax.swing.JProgressBar();
        menuBar = new javax.swing.JMenuBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(modelagemestática.ModelagemEstáticaApp.class).getContext().getResourceMap(Ficha_Info_Proj.class);
        jPanel1.setBackground(resourceMap.getColor("jPanel1.background")); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setForeground(resourceMap.getColor("Nome_D.foreground")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        OK.setText(resourceMap.getString("OK.text")); // NOI18N
        OK.setName("OK"); // NOI18N
        OK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OKActionPerformed(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        Tabela.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        Tabela.setName("Tabela"); // NOI18N
        jScrollPane1.setViewportView(Tabela);

        Nome_D.setFont(resourceMap.getFont("Nome_D.font")); // NOI18N
        Nome_D.setForeground(resourceMap.getColor("Nome_D.foreground")); // NOI18N
        Nome_D.setText(resourceMap.getString("Nome_D.text")); // NOI18N
        Nome_D.setName("Nome_D"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 779, Short.MAX_VALUE)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Nome_D))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(346, 346, 346)
                        .addComponent(OK, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(Nome_D))
                .addGap(11, 11, 11)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 266, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(27, 27, 27)
                .addComponent(OK)
                .addGap(370, 370, 370))
        );

        statusPanel1.setName("statusPanel1"); // NOI18N

        statusPanelSeparator1.setName("statusPanelSeparator1"); // NOI18N

        statusMessageLabel1.setName("statusMessageLabel1"); // NOI18N

        statusAnimationLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel1.setName("statusAnimationLabel1"); // NOI18N

        progressBar1.setName("progressBar1"); // NOI18N

        javax.swing.GroupLayout statusPanel1Layout = new javax.swing.GroupLayout(statusPanel1);
        statusPanel1.setLayout(statusPanel1Layout);
        statusPanel1Layout.setHorizontalGroup(
            statusPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 799, Short.MAX_VALUE)
            .addGroup(statusPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 629, Short.MAX_VALUE)
                .addComponent(progressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel1)
                .addContainerGap())
        );
        statusPanel1Layout.setVerticalGroup(
            statusPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanel1Layout.createSequentialGroup()
                .addComponent(statusPanelSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel1)
                    .addComponent(statusAnimationLabel1)
                    .addComponent(progressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        menuBar.setName("menuBar"); // NOI18N
        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(statusPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 376, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 25, Short.MAX_VALUE)
                .addComponent(statusPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void OKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OKActionPerformed
        // TODO add your handling code here:



        this.dispose();

    }//GEN-LAST:event_OKActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Ficha_Info_Proj().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel Nome_D;
    private javax.swing.JButton OK;
    private javax.swing.JTable Tabela;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar1;
    private javax.swing.JLabel statusAnimationLabel1;
    private javax.swing.JLabel statusMessageLabel1;
    private javax.swing.JPanel statusPanel1;
    // End of variables declaration//GEN-END:variables

}
